PROGRAM Population;

USES RP200;

CONST MaxAge = 100;

TYPE PopCohort = ARRAY [0..1, 0..MaxAge] OF Double;

VAR PopNumber, BirthRate, DeathRate: PopCohort;
    TotalPop: double;

PROCEDURE PopInit;

VAR i,j: word;

BEGIN
     FOR i:= 0 TO 1 DO
         FOR j:= 0 TO MaxAge DO BEGIN
             PopNumber[i,j]:= 100;
             BirthRate[i,j]:= 0;
             DeathRate[i,j]:= j*j/10000
         END;
     FOR j:= 15 TO 45 DO
         BirthRate[1,j]:= 0.15;
     TotalPop:= 0;
     FOR i:= 0 TO 1 DO
         FOR j:= 0 TO MaxAge DO
             TotalPop:= TotalPop+PopNumber[i,j]
END;

PROCEDURE PopUpDate;

VAR i,j: word;
    birth: double;

BEGIN
     birth:= 0;
     FOR j:= 15 TO 45 DO
         birth:= birth + birthrate[1,j]*popnumber[1,j];
     FOR i:= 0 TO 1 DO
         FOR j:= 1 TO MaxAge DO
             PopNumber[i,j]:= PopNumber[i,j-1]*(1-DeathRate[i,j-1]);
     PopNumber[0,0]:= 0.5*birth;
     PopNumber[1,0]:= 0.5*birth;
     TotalPop:= 0;
     FOR i:= 0 TO 1 DO
         FOR j:= 0 TO MaxAge DO
             TotalPop:= TotalPop+PopNumber[i,j]
END;

PROCEDURE Main;

VAR t: word;

BEGIN
     PopInit;
     FOR t:= 1 TO NYear DO
         PopUpdate;
END;

BEGIN
     Main
END.